<template >
    <div class="main-block">
        <select v-model="filter">
            <option value="all">All</option>
            <option value="active">Active</option>
            <option value="completed">Completed</option>
        </select>
        <div class="add-task-block">

                <span ref="addTaskBlock">
                    <button class="add-task-button" @click="openTaskBlock" type="button" name="button">
                    <b>+</b> Add  task
                    </button>
                </span>

        </div>
        <transition name="slide-fade">
            <div v-if="!show" class="textarea-block">
                <div class="input-block">
                    <input  v-model="taskArea" type="text" ref="textareaTask" placeholder="What needs to be done ?">
                    <button  @click="deleteInputString" type="button" name="button">X</button>
                </div>
                <div class="buttons-task-block">
                    <!-- :disabled="validatedInput" -->
                    <button @click="addTask" ref="addButtonTask" type="button" name="button" >Add</button>
                    <button @click="closeTaskBlock" type="button" name="button">Cancel</button>
                </div>
            </div>
        </transition>

        <loader v-if="loading" />
        <div v-else-if="filteredTasks.length" class="added-task-block">
            <p>What you need to do!</p>
            <p class="added-task" :class="{completed: task.completed}" v-for="(task,index)  in Tasks" :key="index">
                <input @click="completedTask" class="completed-checkbox" type="checkbox" >
                <span><b>{{ task.id }}) {{ task.title }}</b></span>
                <button class="taskDeleteButton" @click="deleteTask(index)" type="button" name="button">X</button>
            </p>
        </div>
        <!-- <div v-else-if="this.filteredTasks">
            <p>What you need to do!</p>
            <p class="added-task" :class="{completed: task.completed}" v-for="(task,index)  in Tasks" :key="index">
                <input disabled @click="task.completed = !task.completed" class="completed-checkbox" type="checkbox" >
                <span><b>{{ task.id }}) {{ task.title }}</b></span>
                <button class="taskDeleteButton" @click="deleteTask(index)" type="button" name="button">X</button>
            </p>
        </div> -->
        <div v-else="filteredTasks.length < 1" class="picture-block">
            <span>
                !!! {{ defaultText }} !!!
            </span>
        </div>
    </div>
</template>

<script>
export default {
    computed: {
        filteredTasks() {
            if (this.filter === 'all') {
                return this.Tasks;
            }

            if (this.filter === 'completed') {
                return this.Tasks.filter(t => {t.completed;});
            }

            if (this.filter === 'active') {
                return this.Tasks.filter(t => {!t.completed;});
            }
        }
    },
    methods: {
        deleteTask(index){
            this.Tasks.splice(index, 1);
        },
        deleteInputString() {
            this.taskArea = '';
        },
        addTask() {
            if (this.taskArea.trim()) {
                const newTask = {
                    id: Date.now(),
                    title: this.taskArea,
                    completed: false,
                }
                this.Tasks.push(newTask);
                this.taskArea = '';
                this.$emit('setCounterAll', this.Tasks);
            }
        },
        completedTask (){
            this.Tasks.splice(index, 1);
            this.completedTask.push(newTask);
        },
        // disabledButton() {
        //     if (this.$refs.textareaTask.length > 0) {
        //         this.$refs.addButtonTask.style.background=  'green';
        //     }
        //     else {
        //         this.$refs.addButtonTask.style.background=  'red';
        //     }
        // },
        closeTaskBlock() {
            this.show = !this.show;
            setTimeout(() => {
                this.$refs.addTaskBlock.style.display = 'block';
            }, 1000)
        },
        openTaskBlock() {
            this.$refs.addTaskBlock.style.display = 'none';
            this.show = !this.show;
        }
    },
    mounted() {
        fetch('https://jsonplaceholder.typicode.com/todos?_limit=15')
          .then(response => response.json())
          .then(json => {
              setTimeout(() => {
                this.Tasks = json;
                this.loading = false;
            }, 1000)
          })
    },
    data() {
        return {
            completed: true,
            loading: true,
            filter: 'all',
            taskArea: '',
            removeCompletedTask: '',
            ActiveTasks: [
                {

                }
            ],
            CompletedTasks: [
                {

                }
            ],
            Tasks: [
                {
                    title: 'Do something',
                    completed: true,
                },
                {
                    title: 'Do something',
                    completed: false,
                },
                {
                    title: 'Do something',
                    completed: false,
                },
            ],
            show: true,
            defaultText: 'No tasks, Time to chill',
        }
    }
}
</script>

<style lang="scss" scoped>
    .taskDeleteButton {
        cursor: pointer;

        color: grey;
        font-weight: bold;
        font-size: 15px;

        outline: none;
        border: none;
        &:hover {
            text-shadow: 3px 3px 3px blue;

            transition: .3s all ease;
        }
    }
    .added-task-block {
        .added-task {
            border: 1px solid grey;
            border-radius: 5px;

            padding: 5px 15px;

            display: flex;
            justify-content: space-between;
            align-items: center;

            position: relative;
        }
    }
    .completed-checkbox {
        border-radius: 50%;
    }

    .completed {
        color: grey;

        text-decoration: line-through;
    }
    .slide-fade-enter-active {
        transition: all .3s ease;
    }
    .slide-fade-leave-active {
        transition: all .8s cubic-bezier(1.0, 0.5, 0.8, 1.0);
    }
    .slide-fade-enter, .slide-fade-leave-to
    /* .slide-fade-leave-active до версии 2.1.8 */ {
          transform: translateX(10px);
          opacity: 0;
    }

    .main-block {
        padding: 40px 120px;
        .add-task-button {
            padding: 5px 15px;
            margin-right: 10px;

            border: 1px solid grey;
            border-radius: 5px;
            box-shadow: 0px 2px 11px -2px grey;

            font-weight: bold;
            font-size: 15px;

            outline: none;
            cursor: pointer;
        }
        .add-task-block {
            display: flex;
            justify-content: flex-start;
        }
        .input-block {
            display: flex;
            button {
                margin-left: -40px;

                background: none;
                border: none;

                font-weight: bold;
                font-size: 20px;

                outline: none;
                cursor: pointer;
            }
            input {
                outline: none;

                width: 100%;
                padding: 10px 15px;
                border: 1px solid grey;
                border-radius: 5px;
                box-shadow: 0px 2px 11px -2px grey;
            }
        }
        .buttons-task-block {
            display: flex;

            margin-top: 10px;

            button:nth-child(1) {
                background-color: blue;

                color: white;
            }
            button {
                padding: 5px 15px;
                margin-right: 10px;

                border: 1px solid grey;
                border-radius: 5px;
                box-shadow: 0px 2px 11px -2px grey;

                font-weight: bold;
                font-size: 15px;

                outline: none;
                cursor: pointer;
            }
        }
    }
</style>
